import pygame, sys, time; from pygame.locals import *
TX=TY=8; SZ=50; KENO=5; PER=10 #Plhthos tetragwnwn, megethos tetragwnoy, keno kai ekswteriko perithwrio
BLACK=(0,0,0); WHITE=(255,255,255); RED=(255,0,0); GREEN=(0,255,0); BLUE=(0,0,255); GRAY=(177,177,177)

LP=pygame.image.load('LeykosPyrgos.png'); MP=pygame.image.load('MayrosPyrgos.png')
LI=pygame.image.load('LeykosIppos.png'); MI=pygame.image.load('MayrosIppos.png')
LA=pygame.image.load('LeykosAksiomatikos.png'); MA=pygame.image.load('MayrosAksiomatikos.png')
LV = pygame.image.load('LeykhVasilissa.png'); MV = pygame.image.load('MayrhVasilissa.png')
LR = pygame.image.load('LeykosVasilias.png'); MR = pygame.image.load('MayrosVasilias.png')
LS = pygame.image.load('LeykoPioni.png'); MS = pygame.image.load('MayroPioni.png');

def xyFromMousexMousey(mousex, mousey):
    '''Apo to klik, epistrefontai eite oi syntetagmenes toy tetragwnoy (x,y) eite None.'''
    ypoloipox = ypoloipoy = SZ    
    if mousex > PER and mousey > PER:
        x = int((mousex-PER)/(SZ+KENO)); ypoloipox = (mousex-PER)-x*(SZ+KENO)
        y = int((mousey-PER)/(SZ+KENO)); ypoloipoy = (mousey-PER)-y*(SZ+KENO)
        if ypoloipox<SZ and ypoloipoy<SZ and x<TX and y<TY:
            return x,y
    return None,None

def validMovesAndAttacks(skaki,xx,yy,kommati):
    '''Gia kommati poy vrisketai sto shmeio xx,yy epistrefetai lista
    me epitreptes kinhseis kathws kai lista me epitrepta xtyphmata.'''
    moves = []; attack = []
    if kommati==1 or kommati==-1: #Leykos h Mayros Pyrgos
        x1=xx-1 #Kinhseis pros aristera
        while x1>=0 and skaki[x1][yy]==0:
            moves.append([xx,yy,x1,yy])
            x1=x1-1
        if x1>=0 and skaki[x1][yy]*kommati<0: attack.append([xx,yy,x1,yy])
        x1=xx+1 #Kinhseis pros deksia
        while x1<TX and skaki[x1][yy]==0:
            moves.append([xx,yy,x1,yy])
            x1=x1+1
        if x1<TX and skaki[x1][yy]*kommati<0: attack.append([xx,yy,x1,yy])
        y1=yy-1 #Kinhseis pros epanw
        while y1>=0 and skaki[xx][y1]==0:
            moves.append([xx,yy,xx,y1])
            y1=y1-1
        if y1>=0 and skaki[xx][y1]*kommati<0: attack.append([xx,yy,xx,y1])
        y1=yy+1 #Kinhseis pros katw
        while y1<TY and skaki[xx][y1]==0:
            moves.append([xx,yy,xx,y1])
            y1=y1+1
        if y1<TY and skaki[xx][y1]*kommati<0: attack.append([xx,yy,xx,y1])
    elif kommati==2 or kommati==-2: #Leykos h Mayros Ippos
        x1=xx-1; y1=yy-2
        if x1>=0 and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-2; y1=yy-1
        if x1>=0 and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-2; y1=yy+1
        if x1>=0 and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-1; y1=yy+2
        if x1>=0 and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy+2
        if x1<TX and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+2; y1=yy+1
        if x1<TX and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+2; y1=yy-1
        if x1<TX and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy-2
        if x1<TX and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
    elif kommati==3 or kommati==-3: #Leykos h Mayros Aksiwmatikos
        x1=xx-1; y1=yy-1 #Kinhseis pros panw aristera
        while x1>=0 and y1>=0 and skaki[x1][y1]==0:
            moves.append([xx,yy,x1,y1])
            x1=x1-1; y1=y1-1
        if x1>=0 and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy-1 #Kinhseis pros panw deksia
        while x1<TX and y1>=0 and skaki[x1][y1]==0:
            moves.append([xx,yy,x1,y1])
            x1=x1+1; y1=y1-1 
        if x1<TX and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy+1 #Kinhseis pros katw deksia
        while x1<TX and y1<TY and skaki[x1][y1]==0:
            moves.append([xx,yy,x1,y1])
            x1=x1+1; y1=y1+1  
        if x1<TX and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-1; y1=yy+1 #Kinhseis pros katw aristera
        while x1>=0 and y1<TY and skaki[x1][y1]==0:
            moves.append([xx,yy,x1,y1])
            x1=x1-1; y1=y1+1    
        if x1>=0 and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
    elif kommati==4: #Leykh Vasilissa
        moves1, attack1 = validMovesAndAttacks(skaki,xx,yy,1) #Ypologismos kinhsewn
        moves3, attack3 = validMovesAndAttacks(skaki,xx,yy,3) #me texnikh ths anadromhs
        moves, attack = moves1+moves3, attack1+attack3
    elif kommati==-4: #Mayrh Vasilissa
        moves_1, attack_1 = validMovesAndAttacks(skaki,xx,yy,-1) 
        moves_3, attack_3 = validMovesAndAttacks(skaki,xx,yy,-3)
        moves, attack = moves_1+moves_3, attack_1+attack_3
    elif kommati==5 or kommati==-5: #Leykos h Mayros Vasilias
        x1=xx; y1=yy-1
        if y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx; y1=yy+1
        if y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-1; y1=yy
        if x1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy
        if x1<TX and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-1; y1=yy-1
        if x1>=0 and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-1; y1=yy+1
        if x1>=0 and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy+1
        if x1<TX and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy-1
        if x1<TX and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])   
    elif kommati==6: #Leyko Pioni
        if yy-1>=0 and skaki[xx][yy-1]==0: moves.append([xx,yy,xx,yy-1])
        if yy==6 and skaki[xx][yy-1]==0 and skaki[xx][yy-2]==0: moves.append([xx,yy,xx,yy-2])
        if xx-1>=0 and yy-1>=0 and skaki[xx-1][yy-1]*kommati<0: attack.append([xx,yy,xx-1,yy-1])
        if xx+1<TX and yy-1>=0 and skaki[xx+1][yy-1]*kommati<0: attack.append([xx,yy,xx+1,yy-1])
    elif kommati==-6: #Mayro Pioni
        if yy+1<TY and skaki[xx][yy+1]==0: moves.append([xx,yy,xx,yy+1])
        if yy==1 and skaki[xx][yy+1]==0 and skaki[xx][yy+2]==0: moves.append([xx,yy,xx,yy+2])
        if xx-1>=0 and yy+1<TY and skaki[xx-1][yy+1]*kommati<0: attack.append([xx,yy,xx-1,yy+1])
        if xx+1<TX and yy+1<TY and skaki[xx+1][yy+1]*kommati<0: attack.append([xx,yy,xx+1,yy+1])
    return moves, attack

def drawKommati(xx,yy):
    ''' Sxediazetai to tetragwno kai to kommati ths theshs (xx,yy), symfwna me th domh skaki.
    An to tetragwno einai keno, sxediazetai to katallhlo xrwma tetragwnoy leyko h gkri'''
    if (xx+yy)%2==0: pygame.draw.rect(epif,WHITE,(PER+xx*(SZ+KENO),PER+yy*(SZ+KENO),SZ,SZ),0)
    else: pygame.draw.rect(epif,GRAY,(PER+xx*(SZ+KENO),PER+yy*(SZ+KENO),SZ,SZ),0)
    if skaki[xx][yy]==1: epif.blit(LP, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-1: epif.blit(MP, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==2: epif.blit(LI, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-2: epif.blit(MI, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==3: epif.blit(LA, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-3: epif.blit(MA, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==4: epif.blit(LV, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-4: epif.blit(MV, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==5: epif.blit(LR, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-5: epif.blit(MR, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==6: epif.blit(LS, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-6: epif.blit(MS, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))

pygame.init()
epif=pygame.display.set_mode((2*PER+TX*SZ+(TX-1)*KENO,2*PER+TY*SZ+(TY-1)*KENO))
pygame.display.set_caption('Προσθέτοντας βασιλιάδες και πιόνια στη σκακιέρα')
skaki = [] #Arxikopoihsh skakieras me ekxwrhsh 0 se ola ta tetragwna
for i in range(TX):
    column = []
    for j in range(TY):
        column.append(0) #0 shmainei keno tetragwno
    skaki.append(column)

skaki[0][7]=1; skaki[7][7]=1; skaki[0][0]=-1; skaki[7][0]=-1 #Leykoi kai mayroi pyrgoi
skaki[1][7]=2; skaki[6][7]=2; skaki[1][0]=-2; skaki[6][0]=-2 #Leykoi kai mayroi ippoi
skaki[2][7]=3; skaki[5][7]=3; skaki[2][0]=-3; skaki[5][0]=-3 #Leykoi kai mayroi aksiwmatikoi
skaki[3][7]=4; skaki[3][0]=-4; skaki[4][7]=5; skaki[4][0]=-5 #Leykh kai mayrh vasilissa, leykos kai mayros vasilias
#Leyka kai mayra pionia
skaki[0][6]=6; skaki[1][6]=6; skaki[2][6]=6; skaki[3][6]=6; skaki[4][6]=6; skaki[5][6]=6; skaki[6][6]=6; skaki[7][6]=6
skaki[0][1]=-6; skaki[1][1]=-6; skaki[2][1]=-6; skaki[3][1]=-6; skaki[4][1]=-6; skaki[5][1]=-6; skaki[6][1]=-6; skaki[7][1]=-6

for i in range(TX): #Sxediash skakieras
    for j in range(TY):
        drawKommati(i,j)
        
k=1
turn=1 #Arxika exei seira o leykos kai turn==1. Otan paizei o mayros, turn==-1
while True: #GameLoop
    mouseClicked = False
    for event in pygame.event.get():
        if event.type == QUIT:
            pygame.quit(); sys.exit()
        elif event.type == MOUSEBUTTONUP: #Klik pontikioy
            mousex, mousey = event.pos; mouseClicked = True
    if mouseClicked == True:
        x, y = xyFromMousexMousey(mousex, mousey)
        if  x != None: #Egkyro klik
            if k==1 and skaki[x][y]*turn>0: #An sthn katastash 1 ginei klik se katallhlo kommati      
                klik1x=x; klik1y=y; klik1kommati=skaki[x][y]
                mov, att = validMovesAndAttacks(skaki,x,y,klik1kommati)
                pygame.draw.rect(epif,RED,(PER+x*(SZ+KENO)-2,PER+y*(SZ+KENO)-2,SZ+3,SZ+3),2)
                for mv in mov:
                    pygame.draw.rect(epif,GREEN,(PER+mv[2]*(SZ+KENO)-2,PER+mv[3]*(SZ+KENO)-2,SZ+3,SZ+3),2)
                for mv in att:
                    pygame.draw.rect(epif,BLUE,(PER+mv[2]*(SZ+KENO)-2,PER+mv[3]*(SZ+KENO)-2,SZ+3,SZ+3),2)    
                k=2
            elif k==2 and klik1x==x and klik1y==y: #An ginei deytero klik sto idio kommati
                pygame.draw.rect(epif,BLACK,(PER+klik1x*(SZ+KENO)-2,PER+klik1y*(SZ+KENO)-2,SZ+3,SZ+3),2)
                for mv in mov+att:
                    pygame.draw.rect(epif,BLACK,(PER+mv[2]*(SZ+KENO)-2,PER+mv[3]*(SZ+KENO)-2,SZ+3,SZ+3),2)
                k=1
            elif k==2 and [klik1x,klik1y,x,y] in mov+att: #Egkyro deytero klik
                pygame.draw.rect(epif,BLACK,(PER+klik1x*(SZ+KENO)-2,PER+klik1y*(SZ+KENO)-2,SZ+3,SZ+3),2)
                for mv in mov+att:
                    pygame.draw.rect(epif,BLACK,(PER+mv[2]*(SZ+KENO)-2,PER+mv[3]*(SZ+KENO)-2,SZ+3,SZ+3),2)
                skaki[klik1x][klik1y]=0; skaki[x][y]=klik1kommati
                drawKommati(klik1x,klik1y)
                drawKommati(x,y)          
                k=1
                turn = turn*-1
    pygame.display.update()
