import pygame, sys, time, copy, random; from pygame.locals import *
TX=TY=8; SZ=50; KENO=5; PER=10 #Plhthos tetragwnwn, megethos tetragwnoy, keno kai ekswteriko perithwrio
BLACK=(0,0,0); WHITE=(255,255,255); RED=(255,0,0); GREEN=(0,255,0); BLUE=(0,0,255); GRAY=(177,177,177)

LP=pygame.image.load('LeykosPyrgos.png'); MP=pygame.image.load('MayrosPyrgos.png')
LI=pygame.image.load('LeykosIppos.png'); MI=pygame.image.load('MayrosIppos.png')
LA=pygame.image.load('LeykosAksiomatikos.png'); MA=pygame.image.load('MayrosAksiomatikos.png')
LV=pygame.image.load('LeykhVasilissa.png'); MV=pygame.image.load('MayrhVasilissa.png')
LR=pygame.image.load('LeykosVasilias.png'); MR=pygame.image.load('MayrosVasilias.png')
LS=pygame.image.load('LeykoPioni.png'); MS=pygame.image.load('MayroPioni.png');

def xyFromMousexMousey(mousex, mousey):
    '''Apo to klik, epistrefontai eite oi syntetagmenes toy tetragwnoy (x,y) eite None.'''
    ypoloipox = ypoloipoy = SZ    
    if mousex > PER and mousey > PER:
        x = int((mousex-PER)/(SZ+KENO)); ypoloipox = (mousex-PER)-x*(SZ+KENO)
        y = int((mousey-PER)/(SZ+KENO)); ypoloipoy = (mousey-PER)-y*(SZ+KENO)
        if ypoloipox<SZ and ypoloipoy<SZ and x<TX and y<TY:
            return x,y
    return None,None

def validMovesAndAttacks(skaki,xx,yy,kommati):
    '''Gia kommati poy vrisketai sto shmeio xx,yy epistrefetai lista
    me epitreptes kinhseis kathws kai lista me epitrepta xtyphmata.'''
    moves = []; attack = []
    if kommati==1 or kommati==-1: #Leykos h Mayros Pyrgos
        x1=xx-1 #Kinhseis pros aristera
        while x1>=0 and skaki[x1][yy]==0:
            moves.append([xx,yy,x1,yy])
            x1=x1-1
        if x1>=0 and skaki[x1][yy]*kommati<0: attack.append([xx,yy,x1,yy])
        x1=xx+1 #Kinhseis pros deksia
        while x1<TX and skaki[x1][yy]==0:
            moves.append([xx,yy,x1,yy])
            x1=x1+1
        if x1<TX and skaki[x1][yy]*kommati<0: attack.append([xx,yy,x1,yy])
        y1=yy-1 #Kinhseis pros epanw
        while y1>=0 and skaki[xx][y1]==0:
            moves.append([xx,yy,xx,y1])
            y1=y1-1
        if y1>=0 and skaki[xx][y1]*kommati<0: attack.append([xx,yy,xx,y1])
        y1=yy+1 #Kinhseis pros katw
        while y1<TY and skaki[xx][y1]==0:
            moves.append([xx,yy,xx,y1])
            y1=y1+1
        if y1<TY and skaki[xx][y1]*kommati<0: attack.append([xx,yy,xx,y1])
    elif kommati==2 or kommati==-2: #Leykos h Mayros Ippos
        x1=xx-1; y1=yy-2
        if x1>=0 and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-2; y1=yy-1
        if x1>=0 and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-2; y1=yy+1
        if x1>=0 and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-1; y1=yy+2
        if x1>=0 and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy+2
        if x1<TX and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+2; y1=yy+1
        if x1<TX and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+2; y1=yy-1
        if x1<TX and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy-2
        if x1<TX and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
    elif kommati==3 or kommati==-3: #Leykos h Mayros Aksiwmatikos
        x1=xx-1; y1=yy-1 #Kinhseis pros panw aristera
        while x1>=0 and y1>=0 and skaki[x1][y1]==0:
            moves.append([xx,yy,x1,y1])
            x1=x1-1; y1=y1-1
        if x1>=0 and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy-1 #Kinhseis pros panw deksia
        while x1<TX and y1>=0 and skaki[x1][y1]==0:
            moves.append([xx,yy,x1,y1])
            x1=x1+1; y1=y1-1 
        if x1<TX and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy+1 #Kinhseis pros katw deksia
        while x1<TX and y1<TY and skaki[x1][y1]==0:
            moves.append([xx,yy,x1,y1])
            x1=x1+1; y1=y1+1  
        if x1<TX and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-1; y1=yy+1 #Kinhseis pros katw aristera
        while x1>=0 and y1<TY and skaki[x1][y1]==0:
            moves.append([xx,yy,x1,y1])
            x1=x1-1; y1=y1+1    
        if x1>=0 and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
    elif kommati==4: #Leykh Vasilissa
        moves1, attack1 = validMovesAndAttacks(skaki,xx,yy,1) #Ypologismos kinhsewn
        moves3, attack3 = validMovesAndAttacks(skaki,xx,yy,3) #me texnikh ths anadromhs
        moves, attack = moves1+moves3, attack1+attack3
    elif kommati==-4: #Mayrh Vasilissa
        moves_1, attack_1 = validMovesAndAttacks(skaki,xx,yy,-1) 
        moves_3, attack_3 = validMovesAndAttacks(skaki,xx,yy,-3)
        moves, attack = moves_1+moves_3, attack_1+attack_3
    elif kommati==5 or kommati==-5: #Leykos h Mayros Vasilias
        x1=xx; y1=yy-1
        if y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx; y1=yy+1
        if y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-1; y1=yy
        if x1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy
        if x1<TX and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-1; y1=yy-1
        if x1>=0 and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx-1; y1=yy+1
        if x1>=0 and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1>=0 and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy+1
        if x1<TX and y1<TY and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1<TY and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        x1=xx+1; y1=yy-1
        if x1<TX and y1>=0 and skaki[x1][y1]==0: moves.append([xx,yy,x1,y1])
        elif x1<TX and y1>=0 and skaki[x1][y1]*kommati<0: attack.append([xx,yy,x1,y1])
        if skaki[TX][int(-0.4*kommati+4)]==0: # if skaki[TX][2]==0 h skaki[TX][6]==0 , asaleytos vasilias 
            if skaki[TX+1][int(-0.4*kommati+4)]==0 and skaki[xx+1][yy]==0 and skaki[xx+2][yy]==0: #asaleytos pyrgos,kena
                moves.append([xx,yy,xx+2,yy]) #Mikro roke
            if skaki[TX+1][int(-0.4*kommati+5)]==0 and skaki[xx-1][yy]==0 and skaki[xx-2][yy]==0 and skaki[xx-3][yy]==0:
                moves.append([xx,yy,xx-2,yy]) #Megalo roke   
    elif kommati==6: #Leyko Pioni
        if yy-1>=0 and skaki[xx][yy-1]==0:
            if yy-1!=0: moves.append([xx,yy,xx,yy-1])
            else: moves.append([xx,yy,xx,yy-1,1]); moves.append([xx,yy,xx,yy-1,2]); moves.append([xx,yy,xx,yy-1,3]); moves.append([xx,yy,xx,yy-1,4])
        if yy==6 and skaki[xx][yy-1]==0 and skaki[xx][yy-2]==0: moves.append([xx,yy,xx,yy-2])
        if xx-1>=0 and yy-1>=0 and skaki[xx-1][yy-1]*kommati<0:
            if yy-1!=0: attack.append([xx,yy,xx-1,yy-1])
            else: attack.append([xx,yy,xx-1,yy-1,1]); attack.append([xx,yy,xx-1,yy-1,2]); attack.append([xx,yy,xx-1,yy-1,3]); attack.append([xx,yy,xx-1,yy-1,4])
        if xx+1<TX and yy-1>=0 and skaki[xx+1][yy-1]*kommati<0:
            if yy-1!=0: attack.append([xx,yy,xx+1,yy-1])
            else: attack.append([xx,yy,xx+1,yy-1,1]); attack.append([xx,yy,xx+1,yy-1,2]); attack.append([xx,yy,xx+1,yy-1,3]); attack.append([xx,yy,xx+1,yy-1,4])
        if skaki[TX+1][4]!=0 and yy==3 and abs(skaki[TX+1][4]-1-xx)==1: attack.append([xx,yy,skaki[TX+1][4]-1,yy-1])
    elif kommati==-6: #Mayro Pioni
        if yy+1<TY and skaki[xx][yy+1]==0:
            if yy+1!=7: moves.append([xx,yy,xx,yy+1])
            else: moves.append([xx,yy,xx,yy+1,-1]); moves.append([xx,yy,xx,yy+1,-2]); moves.append([xx,yy,xx,yy+1,-3]); moves.append([xx,yy,xx,yy+1,-4]) 
        if yy==1 and skaki[xx][yy+1]==0 and skaki[xx][yy+2]==0: moves.append([xx,yy,xx,yy+2])
        if xx-1>=0 and yy+1<TY and skaki[xx-1][yy+1]*kommati<0:
            if yy+1!=7: attack.append([xx,yy,xx-1,yy+1])
            else: attack.append([xx,yy,xx-1,yy+1,-1]); attack.append([xx,yy,xx-1,yy+1,-2]); attack.append([xx,yy,xx-1,yy+1,-3]); attack.append([xx,yy,xx-1,yy+1,-4])
        if xx+1<TX and yy+1<TY and skaki[xx+1][yy+1]*kommati<0: 
            if yy+1!=7: attack.append([xx,yy,xx+1,yy+1])
            else: attack.append([xx,yy,xx+1,yy+1,-1]); attack.append([xx,yy,xx+1,yy+1,-2]); attack.append([xx,yy,xx+1,yy+1,-3]); attack.append([xx,yy,xx+1,yy+1,-4])
        if skaki[TX+1][0]!=0 and yy==4 and abs(skaki[TX+1][0]-1-xx)==1: attack.append([xx,yy,skaki[TX+1][0]-1,yy+1])
    return moves, attack

def attackMovesTo(skaki2,x,y,kommati):
    '''Epistrefei lista me tis kinhseis toy antipaloy,
    poy xtypoyn kommati sth thesh x,y.'''
    att = []
    skaki2[x][y]=kommati
    for i in range(1,7):
        m, a = validMovesAndAttacks(skaki2,x,y,i*int(kommati/abs(kommati)))
        for mv in a:
            if skaki2[mv[2]][mv[3]]==(-i)*int(kommati/abs(kommati)):
                tmp1, tmp2 = mv[2], mv[3]
                mv[2], mv[3] = mv[0], mv[1]
                mv[0], mv[1] = tmp1, tmp2
                att.append(mv) 
    return att

def superValidMovesAndAttacks(skaki,xx,yy,kommati):
    '''To ypoprogramma ayto epistrefei ena yposynolo twn kinhsewn poy epistrefei to
    validMovesAndAttacks, kathws exoyn symperilhfthei elegxoi gia ektetheimeno vasilia.
    Gia ena kommati  poy vrisketai sto shmeio xx,yy epistrefontai 2 listes:
    H lista superMoves me orthes kinhseis kai h lista superAttack me ortha xtyphmata.'''
    moves, attack = validMovesAndAttacks(skaki,xx,yy,kommati)
    superMoves=[]; superAttack=[]
    for mv in moves+attack:
        #Dhmioyrgia antigrafoy ths domhs skaki, se eikonikh domh sk
        sk=copy.deepcopy(skaki)
        
        sk[mv[2]][mv[3]]=sk[mv[0]][mv[1]] #Paizetai h kinhsh mv eikonika sth domh sk
        sk[mv[0]][mv[1]]=0
        
        if kommati==5: #Epikairopoihsh twn eikonikwn thesewn twn vasiliadwn
            sk[TX][0]=mv[2]; sk[TX][1]=mv[3]; sk[TX][2]=1
            if mv[2]-mv[0]==2: #Mikro roke
                sk[7][7]=0; sk[5][7]=1 #Topothethsh kai leykoy pyrgoy
                saxMv=attackMovesTo(sk,4,7,5)+attackMovesTo(sk,5,7,5)+attackMovesTo(sk,6,7,5)
            elif mv[0]-mv[2]==2: #Megalo roke
                sk[0][7]=0; sk[3][7]=1 #Topothethsh kai leykoy pyrgoy
                saxMv=attackMovesTo(sk,4,7,5)+attackMovesTo(sk,3,7,5)+attackMovesTo(sk,2,7,5)
            else:
                saxMv=attackMovesTo(sk,sk[TX][0],sk[TX][1],5)
        elif kommati==-5:
            sk[TX][4]=mv[2]; sk[TX][5]=mv[3]; sk[TX][6]=1
            if mv[2]-mv[0]==2: #Mikro roke
                sk[7][0]=0; sk[5][0]=-1 #Topothethsh kai mayroy pyrgoy
                saxMv=attackMovesTo(sk,4,0,-5)+attackMovesTo(sk,5,0,-5)+attackMovesTo(sk,6,0,-5)
            elif mv[0]-mv[2]==2: #Megalo roke
                sk[0][0]=0; sk[3][0]=-1 #Topothethsh kai mayroy pyrgoy
                saxMv=attackMovesTo(sk,4,0,-5)+attackMovesTo(sk,3,0,-5)+attackMovesTo(sk,2,0,-5)
            else:
                saxMv=attackMovesTo(sk,sk[TX][4],sk[TX][5],-5)
        elif kommati==6:
            if mv[1]-mv[3]==2: #An diplh kinhsh leykoy pionioy
                sk[TX+1][0]=mv[2]+1 #Markaretai to shmeio elegxoy an pasan toy leykoy
            elif sk[TX+1][4]!=0 and mv[3]==2 and mv[2]==sk[TX+1][4]-1: #Xtyphma an pasan
                sk[sk[TX+1][4]-1][3]=0 #Feygei to xtyphmeno
            saxMv=attackMovesTo(sk,sk[TX][0],sk[TX][1],5)
        elif kommati==-6:
            if mv[3]-mv[1]==2: #An diplh kinhsh mayroy pionioy
                sk[TX+1][4]=mv[2]+1 #Markaretai to shmeio elegxoy an pasan toy mayroy
            elif sk[TX+1][0]!=0 and mv[3]==5 and mv[2]==sk[TX+1][0]-1: #Xtyphma an pasan
                sk[sk[TX+1][0]-1][4]=0 #Feygei to xtyphmeno
            saxMv=attackMovesTo(sk,sk[TX][4],sk[TX][5],-5)
        elif kommati in [1,2,3,4]:
            saxMv=attackMovesTo(sk,sk[TX][0],sk[TX][1],5)
        else:
            saxMv=attackMovesTo(sk,sk[TX][4],sk[TX][5],-5)
            
        if saxMv==[]: #An den menei ektetheimenos o vasilias, h mv einai orthh
            if mv in moves: superMoves.append(mv)
            else: superAttack.append(mv)
    return superMoves, superAttack

def drawKommati(xx,yy):
    ''' Sxediazetai to tetragwno kai to kommati ths theshs (xx,yy), symfwna me th domh skaki.
    An to tetragwno einai keno, sxediazetai to katallhlo xrwma tetragwnoy leyko h gkri'''
    if (xx+yy)%2==0: pygame.draw.rect(epif,WHITE,(PER+xx*(SZ+KENO),PER+yy*(SZ+KENO),SZ,SZ),0)
    else: pygame.draw.rect(epif,GRAY,(PER+xx*(SZ+KENO),PER+yy*(SZ+KENO),SZ,SZ),0)
    if skaki[xx][yy]==1: epif.blit(LP, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-1: epif.blit(MP, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==2: epif.blit(LI, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-2: epif.blit(MI, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==3: epif.blit(LA, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-3: epif.blit(MA, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==4: epif.blit(LV, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-4: epif.blit(MV, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==5: epif.blit(LR, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-5: epif.blit(MR, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==6: epif.blit(LS, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))
    elif skaki[xx][yy]==-6: epif.blit(MS, (PER + xx*(SZ+KENO),PER + yy*(SZ+KENO),SZ,SZ))

def drawKommatiaProagwghs(turn):
    '''Sxediazontai ta 4 kommatia proagwghs sto katw meros toy tamplo'''
    for i in range(4):
        pygame.draw.rect(epif,WHITE,(PER+(i+2)*(SZ+KENO),PER+(TY+1)*(SZ+KENO),SZ,SZ),0)
    if turn==1:
        epif.blit(LP, (PER + 2*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ))
        epif.blit(LI, (PER + 3*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ))
        epif.blit(LA, (PER + 4*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ))
        epif.blit(LV, (PER + 5*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ))
    elif turn==-1:
        epif.blit(MP, (PER + 2*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ))
        epif.blit(MI, (PER + 3*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ))
        epif.blit(MA, (PER + 4*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ))
        epif.blit(MV, (PER + 5*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ))

def drawKommatiaProagwghsEnd():
    '''Epanaferetai se mayro h perioxh me ta 4 kommatia proagwghs'''
    for i in range(4):
        pygame.draw.rect(epif,BLACK,(PER+(i+2)*(SZ+KENO),PER+(TY+1)*(SZ+KENO),SZ,SZ),0)

def grapseKeimeno(keimeno,size,thesh):
    font = pygame.font.SysFont(None, size)
    text = font.render(keimeno,1,WHITE,BLACK)
    textRect = text.get_rect()
    textRect.center = thesh
    epif.blit(text, textRect)

pygame.init()
epif=pygame.display.set_mode((2*PER+TX*SZ+(TX-1)*KENO,2*PER+TY*SZ+(TY-1)*KENO+(SZ+KENO)*2))
pygame.display.set_caption('Τεχνητή νοημοσύνη (1)')

skaki = [] #Arxikopoihsh skakieras me ekxwrhsh 0 se ola ta tetragwna
for i in range(TX+3):
    column = []
    for j in range(TY):
        column.append(0)
    skaki.append(column)

skaki[0][7]=1; skaki[7][7]=1; skaki[0][0]=-1; skaki[7][0]=-1 #Leykoi kai mayroi pyrgoi
skaki[1][7]=2; skaki[6][7]=2; skaki[1][0]=-2; skaki[6][0]=-2 #Leykoi kai mayroi ippoi
skaki[2][7]=3; skaki[5][7]=3; skaki[2][0]=-3; skaki[5][0]=-3 #Leykoi kai mayroi aksiwmatikoi
skaki[3][7]=4; skaki[3][0]=-4; skaki[4][7]=5; skaki[4][0]=-5 #Leykh kai mayrh vasilissa, leykos kai mayros vasilias
#Leyka kai mayra pionia
skaki[0][6]=6; skaki[1][6]=6; skaki[2][6]=6; skaki[3][6]=6; skaki[4][6]=6; skaki[5][6]=6; skaki[6][6]=6; skaki[7][6]=6
skaki[0][1]=-6; skaki[1][1]=-6; skaki[2][1]=-6; skaki[3][1]=-6; skaki[4][1]=-6; skaki[5][1]=-6; skaki[6][1]=-6; skaki[7][1]=-6
#Arxikes theseis leykoy kai mayroy vasilia
skaki[TX][0]=4; skaki[TX][1]=7; skaki[TX][4]=4; skaki[TX][5]=0

for i in range(TX): #Sxediash skakieras
    for j in range(TY):
        drawKommati(i,j)
        
k=1
skaki[TX+2][0]=1 #Arxika exei seira o leykos (anthrwpos) kai skaki[TX+2][0]=1. -1 otan paizei o mayros (computer).
shmaia=True
while True: #GameLoop
    mouseClicked = False
    for event in pygame.event.get():
        if event.type == QUIT:
            pygame.quit(); sys.exit()
        elif event.type == MOUSEBUTTONUP: #Klik pontikioy
            mousex, mousey = event.pos; mouseClicked = True
    if shmaia==True:
        allMoves=[]
        allAttacks=[]
        for x in range(TX):
            for y in range(TY):
                if skaki[x][y] != 0 and int(skaki[x][y]/abs(skaki[x][y]))==skaki[TX+2][0]:
                    allmov, allatt = superValidMovesAndAttacks(skaki,x,y,skaki[x][y])
                    allMoves = allMoves + allmov
                    allAttacks = allAttacks + allatt
        pygame.draw.rect(epif,BLACK,(PER,PER + TY*(SZ+KENO),TX*(SZ+KENO)-KENO,2*SZ+KENO))
        theshX=int(-0.4*5*skaki[TX+2][0]+2); theshY=int(-0.4*5*skaki[TX+2][0]+3)
        if attackMovesTo(skaki,skaki[TX][theshX],skaki[TX][theshY],5*skaki[TX+2][0]) != []: 
            if allMoves+allAttacks == []:
                grapseKeimeno('ΜΑΤ',50,(PER + int(TX/2)*(SZ+KENO),(TY+1)*(SZ+KENO)))
                skaki[TX][int(-0.4*5*skaki[TX+2][0]+5)]=2 #Kwdikos gia MAT
            else:
                grapseKeimeno('ΣΑΧ',50,(PER + int(TX/2)*(SZ+KENO),(TY+1)*(SZ+KENO)))
                skaki[TX][int(-0.4*5*skaki[TX+2][0]+5)]=1 #Kwdikos gia SAX
        else:
            if allMoves+allAttacks == []:
                grapseKeimeno('ΠΑΤ',50,(PER + int(TX/2)*(SZ+KENO),(TY+1)*(SZ+KENO)))
                skaki[TX][int(-0.4*5*skaki[TX+2][0]+5)]=3 #Kwdikos gia PAT
            else:
                skaki[TX][int(-0.4*5*skaki[TX+2][0]+5)]=0 #Kwdikos gia TIPOTA
        pygame.display.update(); time.sleep(0.5)
        shmaia=False             
    if mouseClicked == True and skaki[TX+2][0]==1 and skaki[TX][3]!=2 and skaki[TX][3]!=3:
        x, y = xyFromMousexMousey(mousex, mousey)
        if  x != None: #Egkyro klik
            if k==1 and skaki[x][y]*skaki[TX+2][0]>0: #An sthn katastash 1 ginei klik se katallhlo kommati      
                klik1x=x; klik1y=y; klik1kommati=skaki[x][y]
                mov, att = superValidMovesAndAttacks(skaki,x,y,klik1kommati)
                if mov+att!=[]:
                    pygame.draw.rect(epif,RED,(PER+x*(SZ+KENO)-2,PER+y*(SZ+KENO)-2,SZ+3,SZ+3),2)
                    for mv in mov:
                        pygame.draw.rect(epif,GREEN,(PER+mv[2]*(SZ+KENO)-2,PER+mv[3]*(SZ+KENO)-2,SZ+3,SZ+3),2)
                    for mv in att:
                        pygame.draw.rect(epif,BLUE,(PER+mv[2]*(SZ+KENO)-2,PER+mv[3]*(SZ+KENO)-2,SZ+3,SZ+3),2)    
                    k=2
            elif k==2 and klik1x==x and klik1y==y: #An ginei deytero klik sto idio kommati
                pygame.draw.rect(epif,BLACK,(PER+klik1x*(SZ+KENO)-2,PER+klik1y*(SZ+KENO)-2,SZ+3,SZ+3),2)
                for mv in mov+att:
                    pygame.draw.rect(epif,BLACK,(PER+mv[2]*(SZ+KENO)-2,PER+mv[3]*(SZ+KENO)-2,SZ+3,SZ+3),2)
                k=1
            elif k==2 and (([klik1x,klik1y,x,y] in mov+att) or ([klik1x,klik1y,x,y,skaki[TX+2][0]] in mov+att)): #Egkyro deytero klik
                pygame.draw.rect(epif,BLACK,(PER+klik1x*(SZ+KENO)-2,PER+klik1y*(SZ+KENO)-2,SZ+3,SZ+3),2)
                for mv in mov+att:
                    pygame.draw.rect(epif,BLACK,(PER+mv[2]*(SZ+KENO)-2,PER+mv[3]*(SZ+KENO)-2,SZ+3,SZ+3),2)
                skaki[klik1x][klik1y]=0; skaki[x][y]=klik1kommati
                drawKommati(klik1x,klik1y); drawKommati(x,y)
                if klik1kommati==5:
                    skaki[TX][0]=x; skaki[TX][1]=y; skaki[TX][2]=1 #Metakinhsh leykoy vasilia
                    if x-klik1x==2: skaki[7][7]=0; skaki[5][7]=1; drawKommati(7,7); drawKommati(5,7) #Mikro roke
                    elif klik1x-x==2: skaki[0][7]=0; skaki[3][7]=1; drawKommati(0,7); drawKommati(3,7) #Megalo roke
                elif klik1kommati==6: #Metakinhsh leykoy pionioy
                    if klik1y-y==2: #An diplh kinhsh leykoy pionioy
                        skaki[TX+1][0]=x+1 #Markaretai to shmeio elegxoy an pasan toy leykoy
                    elif skaki[TX+1][4]!=0 and y==2 and x==skaki[TX+1][4]-1: #An xtyphma an pasan toy leykoy
                        skaki[skaki[TX+1][4]-1][3]=0; drawKommati(skaki[TX+1][4]-1,3) #Feygei to xtyphmeno
                    elif y==0: #Proagwgh leykoy pionioy
                        drawKommatiaProagwghs(skaki[TX+2][0])
                        pygame.display.update()
                        while True:
                            mouseClicked = False
                            for event in pygame.event.get():
                                if event.type == QUIT:
                                    pygame.quit(); sys.exit()
                                elif event.type == MOUSEBUTTONDOWN:
                                    mousex, mousey = event.pos
                                    mouseClicked = True
                            if mouseClicked == True:
                                iRect1 = pygame.Rect(PER + 2*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ)
                                if iRect1.collidepoint(mousex, mousey):
                                    skaki[x][y]=1; drawKommati(x,y);
                                iRect2 = pygame.Rect(PER + 3*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ)
                                if iRect2.collidepoint(mousex, mousey):
                                    skaki[x][y]=2; drawKommati(x,y);
                                iRect3 = pygame.Rect(PER + 4*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ)
                                if iRect3.collidepoint(mousex, mousey):
                                    skaki[x][y]=3; drawKommati(x,y);
                                iRect4 = pygame.Rect(PER + 5*(SZ+KENO),PER + (TY+1)*(SZ+KENO),SZ,SZ)
                                if iRect4.collidepoint(mousex, mousey):
                                    skaki[x][y]=4; drawKommati(x,y);
                            if skaki[x][y]!=6: drawKommatiaProagwghsEnd(); break
                if not(klik1kommati==6 and klik1y-y==2): skaki[TX+1][0]=0 #Epanafora shmeioy elegxoy an pasan toy leykoy
                if not(klik1kommati==-6 and y-klik1y==2): skaki[TX+1][4]=0 #Epanafora shmeioy elegxoy an pasan toy mayroy      
                if (klik1x==7 and klik1y==7) or (x==7 and y==7): skaki[TX+1][2]=1 #Akyrwsh dynatothtas leykoy gia mikro roke
                if (klik1x==0 and klik1y==7) or (x==0 and y==7): skaki[TX+1][3]=1 #Akyrwsh dynatothtas leykoy gia megalo roke
                if (klik1x==7 and klik1y==0) or (x==7 and y==0): skaki[TX+1][6]=1 #Akyrwsh dynatothtas mayroy gia mikro roke
                if (klik1x==0 and klik1y==0) or (x==0 and y==0): skaki[TX+1][7]=1 #Akyrwsh dynatothtas mayroy gia megalo roke          
                k=1
                skaki[TX+2][0] = -1
                shmaia=True
    elif skaki[TX+2][0]==-1 and skaki[TX][7]!=2 and skaki[TX][7]!=3:
        compMove=random.choice(allMoves+allAttacks)
        klik1x=compMove[0]; klik1y=compMove[1]; klik1kommati=skaki[compMove[0]][compMove[1]]
        x=compMove[2]; y=compMove[3]; skaki[klik1x][klik1y]=0; skaki[x][y]=klik1kommati
        pygame.draw.rect(epif,RED,(PER+klik1x*(SZ+KENO)-2,PER+klik1y*(SZ+KENO)-2,SZ+3,SZ+3),2)
        pygame.display.update(); time.sleep(0.5)
        pygame.draw.rect(epif,GREEN,(PER+x*(SZ+KENO)-2,PER+y*(SZ+KENO)-2,SZ+3,SZ+3),2)
        pygame.display.update(); time.sleep(0.5)
        drawKommati(klik1x,klik1y)
        pygame.draw.rect(epif,BLACK,(PER+klik1x*(SZ+KENO)-2,PER+klik1y*(SZ+KENO)-2,SZ+3,SZ+3),2)
        drawKommati(x,y)
        pygame.display.update(); time.sleep(0.5)
        pygame.draw.rect(epif,BLACK,(PER+x*(SZ+KENO)-2,PER+y*(SZ+KENO)-2,SZ+3,SZ+3),2)
        if klik1kommati==-5:
            skaki[TX][4]=x; skaki[TX][5]=y; skaki[TX][6]=1 #Metakinhsh mayroy vasilia
            if x-klik1x==2: skaki[7][0]=0; skaki[5][0]=-1; drawKommati(7,0); drawKommati(5,0) #Mikro roke
            elif klik1x-x==2: skaki[0][0]=0; skaki[3][0]=-1; drawKommati(0,0); drawKommati(3,0) #Megalo roke
        elif klik1kommati==-6: #Metakinhsh mayroy pionioy
            if y-klik1y==2: #An diplh kinhsh mayroy pionioy
                skaki[TX+1][4]=x+1 #Markaretai to shmeio elegxoy an pasan toy mayroy
            elif skaki[TX+1][0]!=0 and y==5 and x==skaki[TX+1][0]-1: #An xtyphma an pasan toy mayroy
                skaki[skaki[TX+1][0]-1][4]=0; drawKommati(skaki[TX+1][0]-1,4) #Feygei to xtyphmeno
            elif y==7:
               skaki[x][y]=compMove[4]; drawKommati(x,y);
        if not(klik1kommati==6 and klik1y-y==2): skaki[TX+1][0]=0 #Epanafora shmeioy elegxoy an pasan toy leykoy
        if not(klik1kommati==-6 and y-klik1y==2): skaki[TX+1][4]=0 #Epanafora shmeioy elegxoy an pasan toy mayroy      
        if (klik1x==7 and klik1y==7) or (x==7 and y==7): skaki[TX+1][2]=1 #Akyrwsh dynatothtas leykoy gia mikro roke
        if (klik1x==0 and klik1y==7) or (x==0 and y==7): skaki[TX+1][3]=1 #Akyrwsh dynatothtas leykoy gia megalo roke
        if (klik1x==7 and klik1y==0) or (x==7 and y==0): skaki[TX+1][6]=1 #Akyrwsh dynatothtas mayroy gia mikro roke
        if (klik1x==0 and klik1y==0) or (x==0 and y==0): skaki[TX+1][7]=1 #Akyrwsh dynatothtas mayroy gia megalo roke                          
        skaki[TX+2][0] = 1
        shmaia=True
    
    pygame.display.update()
